# Quantum Mechanical Keyboard固件

<!---
  original document: 0.15.12:docs/README.md
  git diff 0.15.12 HEAD -- docs/README.md | cat
-->

## 什么是 QMK 固件?

QMK (*Quantum Mechanical Keyboard*) 是一个社区维护的用于开发计算机输入设备的开源软件。社区专注像键盘，鼠标，MIDI设备的各种电子输入设备。社区内的核心小组成员维护[QMK固件](https://github.com/qmk/qmk_firmware)，[QMK配置器](https://config.qmk.fm)（QMK Configurator），[QMK工具箱](https://github.com/qmk/qmk_toolbox)（QMK Toolbox），[qmk.fm](https://qmk.fm)，并与各位社区成员维护这份文档。

## 如何入门

<div class="flex-container">

?> **基础方式** [QMK配置器](zh-cn/newbs_building_firmware_configurator.md) <br>
用户友好的图形界面工具，无需具备编程知识基础。

?> **进阶方式** [基于源代码](zh-cn/newbs.md) <br> 
功能更强大，但门槛较高。

</div>

## 个性化定制

QMK提供了很多功能，对应着很多可供浏览的配套文档。大部分功能都是通过修改[键映射](zh-cn/keymap.md)及[键码](zh-cn/keycodes.md)实现的。

## 需要帮助？

请查阅[寻求帮助页面](zh-cn/support.md)以了解如何获取QMK使用方法的帮助。

## 回馈社区

有多种回馈社区的方法，最简单的方法是开始使用QMK并向你的朋友们推荐它。

* 可以在我们的论坛及聊天室进行互助：
    * [/r/olkb](https://www.reddit.com/r/olkb/)
    * [Discord服务器](https://discord.gg/Uq7gcHh)
* 点击页面下方的“Edit This Page”，可以对文档提供贡献。
* [将这份文档翻译为你的语言](zh-cn/translating.md)
* [上报bug](https://github.com/qmk/qmk_firmware/issues/new/choose)
* [发起Pull Request](zh-cn/contributing.md)
