# The via keymap for navpad 1.0

### Base layer
```
   ,-------------------------------. ,-------.
   | KC_PSCR  | KC_SLCK  | KC_PAUS | |KC_MUTE|
   |----------+----------+----------+-------------------------------------------------.
   | KC_INS   | KC_HOME  | KC_PGUP  | KC_ESC   | KC_PSLS   | KC_PAST  | KC_PMNS       |
   |----------+----------+----------+----------+-----------+----------+---------------|
   | KC_DEL   | KC_END   | KC_PGDN  | KC_P7    | KC_P8     | KC_P9    | KC_PPLS       |
   `--------------------------------+----------+-----------+----------+---------------|
                                    | KC_P4    | KC_P5     | KC_P6    | KC_PPLS       |
   ,--------------------------------+----------+-----------+----------+---------------|
   | S(KC_TAB)| KC_UP    | KC_TAB   | KC_P1    | KC_P2     | KC_P3    | LT(1,KC_PENT) |
   |----------+----------+----------+----------+-----------+----------+---------------|
   | KC_LEFT  | KC_DOWN  | KC_RGHT  | KC_P0    | KC_P0     | KC_PDOT  | LT(1,KC_PENT) |
   '----------------------------------------------------------------------------------`
```
### FN1 layer
```
   ,-------------------------------. ,-------.
   | RESET    | EEP_RST  | KC_NO   | | KC_NO |
   |----------+----------+----------+-------------------------------------------------.
   | KC_NO    | KC_NO    | KC_NO    | KC_NLCK  | KC_QUOT   | KC_PEQL  | KC_NO         |
   |----------+----------+----------+----------+-----------+----------+---------------|
   | KC_CAPS  | KC_NLCK  | KC_SLCK  | S(KC_9)  | KC_UP     | S(KC_0)  | S(KC_SPC)     |
   `--------------------------------+----------+-----------+----------+---------------|
                                    | KC_LEFT  | KC_BTN3   | KC_RGHT  | S(KC_SPC)     |
   ,--------------------------------+----------+-----------+----------+---------------|
   | KC_TRNS  | S(KC_ENT)| KC_TRNS  | KC_BSPC  | KC_DOWN   | KC_DEL   | KC_TRNS       |
   |----------+----------+----------+----------+-----------+----------+---------------|
   | KC_BTN1  | KC_ENT   |S(KC_SPC)|LT(2,KC_SPC)|KC_SPC    | KC_COMM  | KC_TRNS       |
   '----------------------------------------------------------------------------------`
```
### FN2 layer
```
   ,-------------------------------. ,-------.
   | RGB_TOG  | RGB_MOD  | RGB_RMOD| | KC_NO |
   |----------+----------+----------+-------------------------------------------------.
   | RGB_HUI  | RGB_SAI  | RGB_VAI  | KC_NO    | KC_NO     | KC_NO    | KC_NO         |
   |----------+----------+----------+----------+-----------+----------+---------------|
   | RGB_HUD  | RGB_SAD  | RGB_VAD  | KC_NO    | KC_NO     | KC_NO    | KC_NO         |
   `--------------------------------+----------+-----------+----------+---------------|
                                    | KC_NO    | KC_NO     | KC_NO    | KC_NO         |
   ,--------------------------------+----------+-----------+----------+---------------|
   | KC_NO    | KC_NO    | KC_NO    | KC_NO    | KC_NO     | KC_NO    | KC_NO         |
   |----------+----------+----------+----------+-----------+----------+---------------|
   | KC_NO    | KC_NO    | KC_NO    | KC_NO    | KC_NO     | KC_NO    | KC_NO         |
   '----------------------------------------------------------------------------------`
```
### FN3 layer
```
   ,-------------------------------. ,-------.
   | KC_NO    | KC_NO    | KC_NO   | | KC_NO |
   |----------+----------+----------+-------------------------------------------------.
   | KC_NO    | KC_NO    | KC_NO    | KC_NO    | KC_NO     | KC_NO    | KC_NO         |
   |----------+----------+----------+----------+-----------+----------+---------------|
   | KC_NO    | KC_NO    | KC_NO    | KC_NO    | KC_NO     | KC_NO    | KC_NO         |
   `--------------------------------+----------+-----------+----------+---------------|
                                    | KC_NO    | KC_NO     | KC_NO    | KC_NO         |
   ,--------------------------------+----------+-----------+----------+---------------|
   | KC_NO    | KC_NO    | KC_NO    | KC_NO    | KC_NO     | KC_NO    | KC_NO         |
   |----------+----------+----------+----------+-----------+----------+---------------|
   | KC_NO    | KC_NO    | KC_NO    | KC_NO    | KC_NO     | KC_NO    | KC_NO         |
   '----------------------------------------------------------------------------------`
```

## rotary encoder behaviour

|Encoder No.1|CW|CCW|
|---|---|---|
|BASE|tap_code16(KC_WH_U)|tap_code16(KC_WH_D)|
